diff --git a/lib/hive/commands/web/service_installer.rb b/lib/hive/commands/web/service_installer.rb
new file mode 100644
index 00000000..e1b13528
--- /dev/null
+++ b/lib/hive/commands/web/service_installer.rb
@@ -0,0 +1,184 @@
+# frozen_string_literal: true
+
+require "cgi"
+require "shellwords"
+require "hive/commands/service_installer/base"
+
+module Hive
+  module Commands
+    class Web
+      # Per-user autostart installer for the local Rails web UI. Independent
+      # of hive-daemon / hive-bot — separate unit, separate lifecycle.
+      class ServiceInstaller < Hive::Commands::ServiceInstaller::Base
+        def service_name
+          "hive-web"
+        end
+
+        def cli_label
+          "web"
+        end
+
+        def service_noun
+          "web service"
+        end
+
+        def unit_noun
+          "web unit"
+        end
+
+        def target_path
+          case platform
+          when :macos then File.join(@home, "Library/LaunchAgents/local.hive-web.plist")
+          when :linux then File.join(@home, ".config/systemd/user/hive-web.service")
+          end
+        end
+
+        # Start the installed unit via the native service manager.
+        # Returns :ok, :failed, :autostart_unavailable, or :unsupported.
+        def start!
+          case platform
+          when :linux
+            return :autostart_unavailable unless systemctl_available?
+
+            ok = @runner.call([ "systemctl", "--user", "start", service_name ])
+            unless ok
+              @messages << "systemctl --user start #{service_name} failed; " \
+                           "run `systemctl --user status #{service_name}` for details"
+              return :failed
+            end
+            :ok
+          when :macos
+            path = target_path
+            unless path && File.exist?(path)
+              @messages << "web unit not installed at #{path}; run `hive web install` first"
+              return :failed
+            end
+            ok = @runner.call([ "launchctl", "load", path ])
+            unless ok
+              @messages << "launchctl load failed for #{path}"
+              return :failed
+            end
+            :ok
+          else
+            @messages << "web service start is not supported on this platform"
+            :unsupported
+          end
+        end
+
+        # Restart the installed unit so a running Rails process loads a newly
+        # refreshed managed app bundle even when the service definition itself
+        # is unchanged.
+        def restart!
+          case platform
+          when :linux
+            return :autostart_unavailable unless systemctl_available?
+
+            reloaded = @runner.call(%w[systemctl --user daemon-reload])
+            restarted = @runner.call([ "systemctl", "--user", "restart", service_name ])
+            unless reloaded && restarted
+              @messages << "systemctl --user restart #{service_name} failed; " \
+                           "run `systemctl --user status #{service_name}` for details"
+              return :failed
+            end
+            :ok
+          when :macos
+            path = target_path
+            unless path && File.exist?(path)
+              @messages << "web unit not installed at #{path}; run `hive web install` first"
+              return :failed
+            end
+            unless @runner.call([ "launchctl", "unload", path ])
+              @messages << "launchctl unload failed for #{path}"
+              return :failed
+            end
+            unless @runner.call([ "launchctl", "load", path ])
+              @messages << "launchctl load failed for #{path}"
+              return :failed
+            end
+            :ok
+          else
+            @messages << "web service restart is not supported on this platform"
+            :unsupported
+          end
+        end
+
+        # Stop the installed unit via the native service manager.
+        def stop!
+          case platform
+          when :linux
+            return :autostart_unavailable unless systemctl_available?
+
+            ok = @runner.call([ "systemctl", "--user", "stop", service_name ])
+            unless ok
+              @messages << "systemctl --user stop #{service_name} failed"
+              return :failed
+            end
+            :ok
+          when :macos
+            path = target_path
+            unless path && File.exist?(path)
+              @messages << "web unit not installed at #{path}"
+              return :failed
+            end
+            ok = @runner.call([ "launchctl", "unload", path ])
+            unless ok
+              @messages << "launchctl unload failed for #{path} (benign if not loaded)"
+              return :failed
+            end
+            :ok
+          else
+            @messages << "web service stop is not supported on this platform"
+            :unsupported
+          end
+        end
+
+        # Non-mutating status snapshot including whether the manager reports
+        # the job as active/loaded.
+        def status_snapshot
+          state = service_state
+          state.merge(
+            "service_active" => service_active?
+          )
+        end
+
+        private
+
+        def service_active?
+          case platform
+          when :linux
+            return false unless systemctl_available?
+
+            !!@runner.call([ "systemctl", "--user", "is-active", service_name ])
+          when :macos
+            return false unless launchctl_available?
+
+            !!@runner.call([ "launchctl", "list", launchd_label ])
+          else
+            false
+          end
+        end
+
+        def render_systemd
+          template = File.read(File.expand_path("../../../../examples/systemd/hive-web.service", __dir__))
+          escaped = Shellwords.escape(resolved_binary)
+          template
+            .sub(/^ExecStart=.*$/, "ExecStart=#{escaped} web")
+            .sub(/^Environment=PATH=.*$/, build_path_line)
+        end
+
+        def render_launchd
+          template = File.read(File.expand_path("../../../../examples/launchd/hive-web.plist", __dir__))
+          binary = resolved_binary
+          binary_dir = File.dirname(binary)
+          escaped_binary = CGI.escapeHTML(binary)
+          escaped_binary_dir = CGI.escapeHTML(binary_dir)
+          escaped_home = CGI.escapeHTML(@home)
+          template
+            .gsub(%r{<string>/Users/YOU/\.local/bin/hive</string>}, "<string>#{escaped_binary}</string>")
+            .gsub("/Users/YOU/Library/Logs", "#{escaped_home}/Library/Logs")
+            .gsub("/Users/YOU/.local/bin", escaped_binary_dir)
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index da8bd31a..3dd88d91 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -373,6 +373,10 @@ module Hive
         "bind" => "127.0.0.1",
         "port" => 4567,
         "origin" => "http://127.0.0.1:4567",
+        # Local single-user mode: when the bind is loopback, genuine
+        # loopback peers may skip GitHub login. Opt out with false.
+        # Non-loopback binds never use this bypass (see Loopback + Commands::Web).
+        "local_loopback" => true,
         "github" => {
           "owner" => nil,
           # The shared hivebox OAuth app (device flow only — public by
@@ -2291,6 +2295,13 @@ module Hive
               "web.github.#{key} in #{describe_source(source_path)} must be a non-empty String when set"
       end
 
+      local_loopback = web["local_loopback"]
+      unless [ true, false ].include?(local_loopback)
+        raise ConfigError,
+              "web.local_loopback in #{describe_source(source_path)} must be true or false; " \
+              "got #{local_loopback.inspect}"
+      end
+
       secret_file = web["session_secret_file"]
       return if secret_file.nil? || (secret_file.is_a?(String) && !secret_file.strip.empty?)
 
diff --git a/lib/hive/daemon/child_supervisor.rb b/lib/hive/daemon/child_supervisor.rb
index 1b658816..7ee9fc1d 100644
--- a/lib/hive/daemon/child_supervisor.rb
+++ b/lib/hive/daemon/child_supervisor.rb
@@ -3,6 +3,7 @@ require "json"
 require "shellwords"
 require "time"
 require "tmpdir"
+require "hive/daemon/dispatch_request_queue"
 
 module Hive
   module Daemon
@@ -34,12 +35,14 @@ module Hive
       DEFAULT_KILL_GRACE_SEC = 30
 
       def initialize(hive_bin: ENV.fetch("HIVE_BIN", "hive"),
+                     maintenance_binary_resolver: nil,
                      log_dir_for_task: nil,
                      dry_run: false,
                      default_timeout_sec: 0,
                      verb_timeouts: {},
                      kill_grace_sec: DEFAULT_KILL_GRACE_SEC)
         @hive_bin = hive_bin
+        @maintenance_binary_resolver = maintenance_binary_resolver || -> { @hive_bin }
         @dry_run = dry_run
         # Optional injection point: tests pass a lambda taking (project, slug)
         # → an absolute path to write the child's combined stdout/stderr.
@@ -103,9 +106,14 @@ module Hive
           # An unexpected first token is a dispatcher classifier bug.
           raise ArgumentError, "ChildSupervisor refuses non-hive command: #{command_string.inspect}"
         end
-        # Replace literal "hive" with the configured binary so tests
-        # can swap in a fixture path via HIVE_BIN.
-        argv[0] = @hive_bin
+        # Ordinary children keep using the daemon's configured HIVE_BIN.
+        # The reserved repair request is different: its purpose is to
+        # replace that potentially stale service binary, so resolve the
+        # current install candidate at dispatch time.
+        maintenance = Hive::Daemon::DispatchRequestQueue.maintenance_request?(
+          project: project, slug: slug, argv: argv
+        )
+        argv[0] = maintenance ? resolved_maintenance_binary : @hive_bin
 
         timeout_sec = timeout_for_verb(argv_verb(argv))
 
@@ -269,6 +277,13 @@ module Hive
 
       private
 
+      def resolved_maintenance_binary
+        binary = @maintenance_binary_resolver.call
+        return binary unless binary.to_s.empty?
+
+        raise ArgumentError, "ChildSupervisor could not resolve current hive binary for daemon repair"
+      end
+
       def parse_command(command_string)
         Shellwords.split(command_string)
       end
diff --git a/lib/hive/daemon/dispatch_request_queue.rb b/lib/hive/daemon/dispatch_request_queue.rb
index 00d7aacc..4bffd997 100644
--- a/lib/hive/daemon/dispatch_request_queue.rb
+++ b/lib/hive/daemon/dispatch_request_queue.rb
@@ -20,6 +20,14 @@ module Hive
         archive markers
       ].freeze
 
+      # Reserved global project for host-maintenance requests (daemon repair).
+      # Not a real enrolled project; dispatcher bypasses enrollment only for
+      # this sentinel + exact allowlisted argv.
+      GLOBAL_PROJECT = "__hive_host__".freeze
+      GLOBAL_SLUG = "host-maintenance".freeze
+      # Exact argv only — no other global/daemon argv may be enqueued.
+      MAINTENANCE_ARGV = %w[hive daemon install --force].freeze
+
       DIRNAME = "dispatch_requests".freeze
       CLAIMED_SUFFIX = ".claimed".freeze
       CLAIM_META_SUFFIX = ".claim".freeze
@@ -51,7 +59,7 @@ module Hive
       def write_request!(project:, slug:, argv:, requestor: "bot", chat_id: nil,
                          update_id: nil, trigger: nil, request_id: generate_request_id,
                          state_home: Hive::Paths.state_home, now: Time.now)
-        unless valid_argv?(argv)
+        unless valid_argv?(argv, project: project, slug: slug)
           raise ArgumentError, "argv #{argv.inspect} is not allowlisted for dispatch requests"
         end
         raise ArgumentError, "project is required for dispatch requests" if project.to_s.empty?
@@ -339,12 +347,17 @@ module Hive
         )
       end
 
-      def valid_argv?(argv)
+      def valid_argv?(argv, project: nil, slug: nil)
         return false unless argv.is_a?(Array)
         return false if argv.length < 2
         return false unless argv.all? { |tok| tok.is_a?(String) && !tok.empty? }
         return false unless argv[0] == "hive"
 
+        # Host maintenance is valid only for the complete reserved tuple.
+        # Keeping this check contextual prevents an exact maintenance argv
+        # from riding an enabled real project's ordinary dispatch gates.
+        return maintenance_request?(project: project, slug: slug, argv: argv) if argv == MAINTENANCE_ARGV
+
         verb = argv[1].to_s
         return false unless ALLOWED_VERBS.include?(verb)
         return true if argv.length < 3
@@ -354,6 +367,12 @@ module Hive
         SLUG_RE.match?(argv[2])
       end
 
+      def maintenance_request?(project:, slug:, argv:)
+        project.to_s == GLOBAL_PROJECT &&
+          slug.to_s == GLOBAL_SLUG &&
+          argv == MAINTENANCE_ARGV
+      end
+
       def filename_for(created_at:, request_id:)
         ts = created_at.utc.strftime("%Y%m%dT%H%M%S%6N")
         "#{ts}-#{request_id}.json"
diff --git a/lib/hive/daemon/dispatcher.rb b/lib/hive/daemon/dispatcher.rb
index 1960febf..b9da1a50 100644
--- a/lib/hive/daemon/dispatcher.rb
+++ b/lib/hive/daemon/dispatcher.rb
@@ -1326,7 +1326,11 @@ module Hive
       # checks AND the actual spawn. Returns nil; side effects via
       # @controller, @logger, and the queue's remove() call.
       def process_dispatch_request_iteration(req, now:)
-        unless Hive::Daemon::DispatchRequestQueue.valid_argv?(req.argv)
+        unless Hive::Daemon::DispatchRequestQueue.valid_argv?(
+          req.argv,
+          project: req.project,
+          slug: req.slug
+        )
           reject_request(req, reason: "invalid_argv")
           return
         end
@@ -1336,27 +1340,34 @@ module Hive
           return
         end
 
-        unless Hive::Config.find_project(req.project)
-          reject_request(req, reason: "unknown_project")
-          return
-        end
+        maintenance = Hive::Daemon::DispatchRequestQueue.maintenance_request?(
+          project: req.project, slug: req.slug, argv: req.argv
+        )
 
-        # C4 from PR #241 ce-code-review: gate on project_enabled? so a
-        # disabled project's queued requests don't dispatch. The
-        # auto-advance path (handle_row) already does this; the
-        # request path must mirror to keep the single-dispatcher
-        # invariant honest.
-        unless project_enabled?(req.project)
-          @logger.event(:dispatch_request_blocked,
-                        request_id: req.request_id, project: req.project,
-                        slug: req.slug, reason: "project_disabled")
-          return
+        unless maintenance
+          unless Hive::Config.find_project(req.project)
+            reject_request(req, reason: "unknown_project")
+            return
+          end
+
+          # C4 from PR #241 ce-code-review: gate on project_enabled? so a
+          # disabled project's queued requests don't dispatch. The
+          # auto-advance path (handle_row) already does this; the
+          # request path must mirror to keep the single-dispatcher
+          # invariant honest.
+          unless project_enabled?(req.project)
+            @logger.event(:dispatch_request_blocked,
+                          request_id: req.request_id, project: req.project,
+                          slug: req.slug, reason: "project_disabled")
+            return
+          end
         end
 
         # Reverse the gate-evaluation order from the previous version:
         # check the cheap, deterministic running_task? gate first so an
         # in-flight slug doesn't incur the can_dispatch? scan. Per R-04
-        # / M-05 from PR #241 ce-code-review.
+        # / M-05 from PR #241 ce-code-review. Also dedupes concurrent
+        # host-maintenance repair requests under the same sentinel slug.
         if @controller.running_task?(project: req.project, slug: req.slug)
           @logger.event(:dispatch_request_blocked,
                         request_id: req.request_id, project: req.project,
@@ -1364,16 +1375,18 @@ module Hive
           return
         end
 
-        gate = @controller.can_dispatch?(
-          project: req.project, slug: req.slug, now: now,
-          external_global_count: @external_active_agent_total,
-          external_project_count: external_active_agent_count_for(req.project)
-        )
-        unless gate == :ok
-          @logger.event(:dispatch_request_blocked,
-                        request_id: req.request_id, project: req.project,
-                        slug: req.slug, reason: gate.to_s)
-          return
+        unless maintenance
+          gate = @controller.can_dispatch?(
+            project: req.project, slug: req.slug, now: now,
+            external_global_count: @external_active_agent_total,
+            external_project_count: external_active_agent_count_for(req.project)
+          )
+          unless gate == :ok
+            @logger.event(:dispatch_request_blocked,
+                          request_id: req.request_id, project: req.project,
+                          slug: req.slug, reason: gate.to_s)
+            return
+          end
         end
 
         dispatch_request!(req, now: now)
diff --git a/lib/hive/daemon/status_report.rb b/lib/hive/daemon/status_report.rb
new file mode 100644
index 00000000..3435dea4
--- /dev/null
+++ b/lib/hive/daemon/status_report.rb
@@ -0,0 +1,215 @@
+# frozen_string_literal: true
+
+require "hive"
+require "hive/bounded_subprocess"
+require "hive/paths"
+require "hive/pid_file"
+require "hive/update_check/state"
+
+module Hive
+  module Daemon
+    # Shared producer of the `hive-daemon-status` payload for CLI and web.
+    # Returns a plain Hash — never captures `$stdout` — so threaded Puma
+    # can call it safely. Binary version probes are bounded.
+    class StatusReport
+      include Hive::PidFile
+
+      VERSION_PROBE_TIMEOUT_SEC = 2
+      DRIFT_NONE = "none"
+      DRIFT_PATH = "path"
+      DRIFT_VERSION = "version"
+      DRIFT_UNPARSEABLE = "unparseable"
+      DRIFT_UNREADABLE = "unreadable"
+      DRIFT_NOT_APPLICABLE = "not_applicable"
+      DRIFT_VALUES = [
+        DRIFT_NONE, DRIFT_PATH, DRIFT_VERSION, DRIFT_UNPARSEABLE,
+        DRIFT_UNREADABLE, DRIFT_NOT_APPLICABLE
+      ].freeze
+
+      def initialize(
+        hive_home: Hive::Paths.state_home,
+        binary_path: nil,
+        installer: nil,
+        version_probe: nil,
+        update_state: nil,
+        running_state: nil
+      )
+        @hive_home = hive_home
+        @binary_path = binary_path
+        @installer = installer
+        @version_probe = version_probe || method(:default_version_probe)
+        @update_state = update_state
+        # Optional override: [running, pid, uptime_sec]. Used by Commands::Daemon
+        # so existing PID ownership stubs on the command still apply.
+        @running_state_override = running_state
+      end
+
+      def to_h
+        running, pid, uptime_sec = @running_state_override || detect_running_state
+        service = probe_service_state
+        drift = compute_drift(service)
+        {
+          "schema" => "hive-daemon-status",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-daemon-status"),
+          "ok" => true,
+          "running" => running,
+          "pid" => running ? pid : nil,
+          "uptime_sec" => uptime_sec,
+          "pid_file" => pid_file,
+          "log_file" => log_file,
+          "service_installed" => service["service_installed"],
+          "service_enabled" => service["service_enabled"],
+          "unit_path" => service["unit_path"],
+          "current_version" => Hive::VERSION,
+          "update_nudge" => update_nudge_payload,
+          "expected_binary" => service["expected_binary"],
+          "installed_binary" => service["installed_binary"],
+          "installed_version" => service["installed_version"],
+          "binary_drift" => drift
+        }
+      end
+
+      # Subset safe for dashboard rendering (no filesystem secrets beyond
+      # already-public status paths).
+      def safe_payload
+        to_h
+      end
+
+      private
+
+      def pid_file
+        File.join(@hive_home, ".daemon.pid")
+      end
+
+      def log_file
+        File.join(@hive_home, "logs", "daemon.log")
+      end
+
+      def detect_running_state
+        pid = read_live_pid
+        return [ false, nil, nil ] unless pid
+
+        uptime = (Time.now - File.stat(pid_file).mtime).to_i
+        [ true, pid, uptime ]
+      rescue StandardError
+        [ false, nil, nil ]
+      end
+
+      def probe_service_state
+        installer = resolve_installer
+        state = installer.service_state
+        expected = installer.resolved_binary_for_status
+        installed = installer.installed_binary_path
+        installed_version = nil
+        version_probe_failed = false
+        if installed && File.executable?(installed)
+          installed_version = probe_installed_version(installed)
+          version_probe_failed = installed_version.nil?
+        elsif installed
+          version_probe_failed = true
+        end
+        state.merge(
+          "expected_binary" => expected,
+          "installed_binary" => installed,
+          "installed_version" => installed_version,
+          "version_probe_failed" => version_probe_failed,
+          "binary_parse_error" => installer.binary_parse_error
+        )
+      rescue StandardError => e
+        {
+          "service_installed" => nil,
+          "service_enabled" => nil,
+          "unit_path" => nil,
+          "expected_binary" => nil,
+          "installed_binary" => nil,
+          "installed_version" => nil,
+          "version_probe_failed" => false,
+          "binary_parse_error" => "unreadable: #{e.class}: #{e.message}"
+        }
+      end
+
+      def resolve_installer
+        return @installer if @installer
+
+        require "hive/commands/daemon/service_installer"
+        Hive::Commands::Daemon::ServiceInstaller.new(binary_path: @binary_path)
+      end
+
+      def compute_drift(service)
+        if service["binary_parse_error"].to_s.start_with?("unreadable")
+          return DRIFT_UNREADABLE
+        end
+
+        unit_path = service["unit_path"]
+        installed_flag = service["service_installed"]
+        if unit_path.nil? && installed_flag.nil?
+          return DRIFT_UNREADABLE
+        end
+        if installed_flag == false || unit_path.nil?
+          return DRIFT_NOT_APPLICABLE
+        end
+
+        installed = service["installed_binary"]
+        expected = service["expected_binary"]
+        if installed.nil?
+          return service["binary_parse_error"] ? DRIFT_UNPARSEABLE : DRIFT_UNREADABLE
+        end
+
+        return DRIFT_UNREADABLE if service["version_probe_failed"]
+
+        if expected && paths_differ?(installed, expected)
+          return DRIFT_PATH
+        end
+
+        installed_version = service["installed_version"]
+        if installed_version && installed_version != Hive::VERSION
+          return DRIFT_VERSION
+        end
+
+        DRIFT_NONE
+      end
+
+      def paths_differ?(a, b)
+        File.expand_path(a.to_s) != File.expand_path(b.to_s)
+      rescue StandardError
+        a.to_s != b.to_s
+      end
+
+      def update_nudge_payload
+        state = @update_state || Hive::UpdateCheck::State.new
+        nudge = state.nudge
+        return nil unless nudge
+
+        { "latest" => nudge.latest, "channel" => nudge.channel, "command" => nudge.command }
+      rescue StandardError
+        nil
+      end
+
+      def default_version_probe(binary)
+        out, err, status = Hive::BoundedSubprocess.capture3(
+          binary,
+          "--version",
+          timeout: VERSION_PROBE_TIMEOUT_SEC
+        )
+        return nil unless status.success?
+
+        text = "#{out}\n#{err}"
+        # hive --version prints "hive 0.3.2" or just "0.3.2"
+        match = text.match(/(\d+\.\d+\.\d+)/)
+        match && match[1]
+      rescue Hive::BoundedSubprocess::TimeoutError,
+             Errno::ENOENT, Errno::EACCES, SystemCallError
+        nil
+      end
+
+      def probe_installed_version(binary)
+        version = @version_probe.call(binary)
+        return version if version.to_s.match?(/\A\d+\.\d+\.\d+(?:[-+][0-9A-Za-z.-]+)?\z/)
+
+        nil
+      rescue StandardError
+        nil
+      end
+    end
+  end
+end
diff --git a/lib/hive/paths.rb b/lib/hive/paths.rb
index 752a5c7d..0bb75dee 100644
--- a/lib/hive/paths.rb
+++ b/lib/hive/paths.rb
@@ -20,6 +20,18 @@ module Hive
       hive_home_override || File.join(base_home("XDG_CACHE_HOME", ".cache"), "hive")
     end
 
+    # Managed Rails app tree installed by `Hive::Web::AppBundle` for local
+    # (non-Docker) web mode. Lives under XDG data — not state — because the
+    # app is a version-matched release asset, not mutable runtime data.
+    # SQLite/session storage stays under state_home (see Commands::Web).
+    def web_app_home
+      File.join(data_home, "web-app")
+    end
+
+    def web_app_version_stamp_path
+      File.join(web_app_home, ".hive-web-version")
+    end
+
     def task_counter_path
       File.join(state_home, "task-counter.yml")
     end
